<?php declare(strict_types=1);

/*
 *     Copyleft (C) 2017  http://sikofitt.com sikofitt@gmail.com
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Sikofitt\Yamaha\AV\Command;

interface CommandInterface
{
    public const TOGGLE = 1;

    /**
     * This should be the endpoint without the YamahaExtendedControl/v?
     * It could be 'main/setMute' for example.
     *
     * You can use {zone} as a replacement for the current zone.
     *
     * @return string
     */
    public static function getEndPoint(): string;

    public static function getType(): string;
}
