<?php
/**
 * Created by PhpStorm.
 * User: eric
 * Date: 10/31/17
 * Time: 3:53 PM
 */

namespace Sikofitt\Yamaha\AV\Controller;



use Sikofitt\Yamaha\AV\Client\Client;
use Sikofitt\Yamaha\AV\Client\System;
use Sikofitt\Yamaha\AV\Repository\UserRepository;
use Silex\Application;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class SystemController
{

    private $userRepository;

    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    public function statusCommand(Request $request, Application $app)
    {
        $content = \json_decode($request->getContent(), true);

        if(null === $content) {
            $app->abort(Response::HTTP_EXPECTATION_FAILED);
        }

        if(isset($content['api_key'], $content['api_secret'])) {
            $user = $this->userRepository->getUserByKeyAndSecret($content['api_key'], $content['api_secret']);
        }

        if(isset($content['username'], $content['password'])) {
            $user = $this->userRepository->getUserByUserName($content['username']);
            dump($user);
            if(false === password_verify($content['password'], (string)$user['password']))
            {
                $app->abort(Response::HTTP_UNAUTHORIZED, 'Either your username or password is incorrect.  Please try again.');
            }
        }

        if(isset($content['api_token'])) {
            $user = $this->userRepository->getUserByToken($content['api_token']);
            if(true === $this->userRepository->isTokenExpired($user)) {
                $app->abort(Response::HTTP_EXPECTATION_FAILED, 'Your token has expired.');
            }
        }

        if(empty($user)) {
            $app->abort(Response::HTTP_UNAUTHORIZED, 'Could not validate the user.');
        }

        $client = new Client('10.5.7.230');
        $system = new System($client);

        return new JsonResponse([
          'status' => 200,
          'features' => $system->getFeatures(),
        ]);

    }
}