<?php
/**
 * Created by PhpStorm.
 * User: eric
 * Date: 11/1/17
 * Time: 1:26 PM
 */

namespace Sikofitt\Yamaha\AV\Controller;


use Sikofitt\Yamaha\AV\Repository\UserRepository;
use Silex\Application;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class UserController
{
    private $userRepository;

    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    public function updateTokenAction(Request $request, Application $app)
    {
        $json = \json_decode($request->getContent());
        if(null === $json) {
            $app->abort(Response::HTTP_EXPECTATION_FAILED, json_last_error_msg());
        }

        if(false === isset($json['username'], $json['password'])) {
            $app->abort(Response::HTTP_UNAUTHORIZED, 'Required values \'username\' or \'password\' were not found.');
        }
        $success = $this->userRepository->createApiTokenForUser($json['username']);
        $token = $this->userRepository->getApiToken($json['username']);
        if(null === $token) {
            $data = null;
        } else {
            $data = [
              'api_token' => $token['api_token'],
              'api_token_expire' => $token['api_token_expire'],
            ];
        }
        dump($data);
        return new JsonResponse([
          'success' => $success,
           $data,
        ]);


    }


}