<?php
/**
 * Created by PhpStorm.
 * User: eric
 * Date: 11/1/17
 * Time: 2:02 PM
 */

namespace Sikofitt\Yamaha\AV\Provider;


use Pimple\Container;
use Pimple\ServiceProviderInterface;
use Silex\Api\BootableProviderInterface;
use Silex\Api\ControllerProviderInterface;
use Silex\Api\EventListenerProviderInterface;
use Silex\Application;
use Silex\ControllerCollection;
use Symfony\Component\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Event\FilterResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;

class AuthenticationProvider implements EventListenerProviderInterface, BootableProviderInterface, ServiceProviderInterface
{

    /**
     * Bootstraps the application.
     *
     * This method is called after all services are registered
     * and should be used for "dynamic" configuration (whenever
     * a service must be requested).
     *
     * @param Application $app
     */
    public function boot(Application $app)
    {
        // TODO: Implement boot() method.
    }

    /**
     * Registers services on the given container.
     *
     * This method should only be used to configure services and parameters.
     * It should not get services.
     *
     * @param Container $pimple A container instance
     */
    public function register(Container $pimple)
    {
        // TODO: Implement register() method.
    }

    public function subscribe(
      Container $app,
      EventDispatcherInterface $dispatcher
    ) {
        $dispatcher->addListener(KernelEvents::REQUEST, function(FilterResponseEvent $event) use ($app) {
            $json = \json_decode($event->getRequest()->getContent(), true);
            if(null === $json) {
                $response = new JsonResponse([
                  'success' => false,
                  'code' => Response::HTTP_UNAUTHORIZED,
                  'message' => Response::$statusTexts[Response::HTTP_UNAUTHORIZED],
                ]);

                $event->setResponse($response);
            }

        });
    }
}