<?php
/**
 * Created by PhpStorm.
 * User: eric
 * Date: 11/1/17
 * Time: 3:17 PM
 */

namespace Sikofitt\Yamaha\AV\Security;


use Doctrine\DBAL\Connection;
use Doctrine\DBAL\Platforms\MySqlPlatform;
use Doctrine\DBAL\Platforms\SqlitePlatform;
use Doctrine\DBAL\Types\Type;
use Sikofitt\Yamaha\AV\Repository\UserRepository;

class UserAuthChecker
{
    private $userRepository;

    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    public function check(array $postData): bool
    {
        if(isset($postData['api_token'])) {
            return $this->isTokenValid($postData['api_token']);
        }

        if(isset($postData['api_key'], $postData['api_secret'])) {
            return $this->checkApiKey($postData['api_key'], $postData['api_secret']);
        }

        if(isset($postData['user_name'], $postData['password'])) {
            return $this->checkUserPassword($postData['user_name'], $postData['password']);
        }

    }

    public function isTokenValid($apiToken): bool
    {
        $user = $this->userRepository->getUserByToken($apiToken);

        if(false === isset($user['api_token_expire']) && null === $user['api_token_expire']) {
            return false;
        }

        if(true === $this->isTokenExpired((string)$user['api_token_expire']))
        {
            return false;
        }

        return true;
    }

    public function checkApiKey($apiKey, $apiSecret): bool
    {

    }

    public function checkUserPassword($userName, $password): bool
    {

    }

    public function isTokenExpired(string $tokenExpire): bool
    {
            $expireDate = Type::getType(Type::DATETIME)
              ->convertToPHPValue($tokenExpire, new SqlitePlatform());

            $currentDate = new \DateTime('now');

            return $currentDate->format('U') > $expireDate->format('U');
    }

}